var dimension = 2;
var X = new Array(new Array(0, 1), new Array(0, 1));
var epsilon = 0.000001;

// set random points //

var A = new Array(8);

function init_problem () {
  for (var k = 0; k < A.length; k++) A[k] = new Array(Math.random(), Math.random());
}

// objective function //

function distance (a, x) {
  return Math.sqrt((a[0]-x[0])*(a[0]-x[0]) + (a[1]-x[1])*(a[1]-x[1]));
}

function f (x) {
  var h = distance(A[0], x);
  for (var k = 1; k < A.length; k++) h = Math.max(h, distance(A[k], x));
  return h;
}

// lower bounds by the use of interval arithmetic //

function distance_I (a, I) {
  return IA.sqrt(IA.add(IA.sq(IA.add_scalar(-a[0], I[0])), IA.sq(IA.add_scalar(-a[1], I[1]))));
}

function LB (I) {
  var H = distance_I(A[0], I);
  for (var k = 1; k < A.length; k++) H = IA.max(H, distance_I(A[k], I));
  return H[0];
}

// problem visualization //

function plot_problem (y) {
  PV.set_size(-0.2, 1.2, -0.2, 1.2, 1.0);

  PV.disc(y[0], y[1], f(y), '#E0E0E0');
  for (var k = 0; k < A.length; k++) PV.dot(A[k][0], A[k][1]);
  PV.disc(y[0], y[1], 0.01, '#FF0000');

  PV.head("Problem Visualization");
}